/// in deviations from linear trend ///
/// and dropping after 2007
clear
use "D:\My Data\_Rutgers\Econ508 - Econometrics II\Final paper\yci_kalman.dta"
tsset time, q
drop if tin(2007q1,2011q2)
//drop if tin(1947q1,1969q4)

foreach var of varlist y c i {
reg `var' time
predict `var'_hat
gen `var'_det=`var'-`var'_hat
}

constraint define 1 [tfp]L.tfp = 1
sspace (tfp L.tfp, state noconstant) (y_det tfp, nocons ) ///
(c_det tfp, noconstant) (i_det tfp, nocons),   ///
constraints(1)  covstate(identity)  //

predict tfp_hat, state equation(tfp) 
predict y_trend, equation(y_det)
predict c_trend, equation(c_det)
predict i_trend, equation(i_det)

foreach var of varlist y c i {
gen `var'_trans=`var'_det-`var'_trend
}

predict trend, state equation(tfp) smethod(smooth) rmse(rmse)

